Scriptname zadGagScript extends zadEquipScript
Message Property callForHelpMsg Auto
Message Property zad_GagPreEquipMsg Auto
Message Property zad_GagEquipMsg Auto
Message Property zad_GagRemovedMsg Auto
Message Property zad_GagPickLockFailMsg Auto
Message Property zad_GagPickLockSuccessMsg Auto
Message Property zad_GagArmsTiedMsg Auto
Message Property zad_GagBruteForceArmsTiedMsg Auto
Message Property zad_GagBruteForceMsg Auto
import MfgConsoleFunc

Function OnEquippedPre(actor akActor, bool silent=false)
	if !silent
		if akActor == libs.PlayerRef
			zad_GagEquipMsg.Show()
		Else
			libs.NotifyActor("You slip the gag into "+GetMessageName(akActor)+" mouth, and lock it securely in place behind "+GetMessageName(akActor)+" head.", akActor, true)
		EndIf
	EndIf
	Parent.OnEquippedPre(akActor, silent)
EndFunction

Function DeviceMenuExt(int msgChoice)
	if msgChoice == 3
		libs.Moan(libs.PlayerRef)
		callForHelpMsg.Show()
	elseif msgChoice == 4 ;Cut through the strap
		DeviceMenuCut()
	EndIf
EndFunction

;==========
;Cut
;==========
string Function DeviceMenuCutSuccess()
	RemoveDevice(libs.PlayerRef)
	return ""
EndFunction
string Function DeviceMenuCutModerate()
	Aroused.UpdateActorExposure(libs.PlayerRef, 1)
	return ""
EndFunction
string Function DeviceMenuCutFail()
	libs.PlayerRef.DamageAV("Health", 5)
	libs.Moan(libs.PlayerRef)
	libs.UpdateExposure(libs.PlayerRef, 1)
	return ""
EndFunction
Function DeviceMenuCut()
	string skillName = "onehanded"
	int unlockChance = libs.CheckDeviceEscape(60, skillName)
	string out = ""
        if (unlockChance == -1)
		out += "You carefully slip the cold blade of your dagger between your skin and one of the straps on the device. After some time you manage to saw through the strap and then wrest your way out of the device. You find that you can easily replace the strap, but putting the device back on without the key in your possession is probably a bad idea."
		out += DeviceMenuCutSuccess()
	elseif (unlockChance >= 100)
		out += "You carefully slip the cold blade of your dagger between your skin and one of the straps on the device. You can't find a way to saw through the strap without cutting yourself, but the cold steel leaves you feeling slightly more aroused."
		DeviceMenuCutModerate()
	else
		out += "You carefully slip the cold blade of your dagger between your skin and one of the straps on the device, but being unfamiliar with the use of blades you accidentally cut yourself. The pain and the cold steel on your skin combine to incite your body's urges."
		out += DeviceMenuCutFail()
	endif
	libs.Notify(out, messageBox=true)
EndFunction

int Function OnEquippedFilter(actor akActor, bool silent=false)
	if akActor != libs.PlayerRef || silent
		return 0 ; Proceed.
	EndIf
        int interaction = zad_GagPreEquipMsg.show()
        if interaction == 0 ; Equip Device
		return 0 ; Proceed
	Else
		return 2
	EndIf
EndFunction


string Function DeviceMenuPickLockSuccess()
	RemoveDevice(libs.PlayerRef)
	zad_GagPickLockSuccessMsg.Show()
	return ""
EndFunction
string Function DeviceMenuPickLockModerate()
	return ""
EndFunction
string Function DeviceMenuPickLockFail()
	libs.PlayerRef.RemoveItem(Lockpick)
	zad_GagPickLockFailMsg.Show()
	return ""
EndFunction

Function DeviceMenuPickLock()
	string skillName = ""
	if libs.Config.SkyRe
		skillName = "Pickpocket"
	else
		skillName = "Lockpicking"
	EndIf
	if libs.PlayerRef.WornHasKeyword(libs.zad_DeviousArmbinder)
		zad_GagArmsTiedMsg.Show()
		return
	EndIf
	int unlockChance = libs.CheckDeviceEscape(libs.GetUnlockThreshold(), skillName)
        if (unlockChance == -1)
		DeviceMenuPickLockSuccess()
	else
		DeviceMenuPickLockFail()
	endif
EndFunction

Function DeviceMenuBruteForce()
	if libs.PlayerRef.WornHasKeyword(libs.zad_DeviousArmbinder)
		zad_GagBruteForceArmsTiedMsg.Show()
	Else
		zad_GagBruteForceMsg.show()
	EndIf
EndFunction



Function OnRemoveDevice(actor akActor)
	if !libs.IsAnimating(akActor)
		akActor.ClearExpressionOverride()
		ResetPhonemeModifier(akActor)
	EndIf
EndFunction

Function OnEquippedPost(actor akActor)
	libs.ApplyGagEffect(akActor)
EndFunction
